import { _decorator, Component, Node, NodeEventType, EventTouch, UITransform } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('test')
export class test extends Component {
    
    start() {
        this.node.on(NodeEventType.TOUCH_END, this._onTouchEnded, this, true);
    }

    protected _onTouchEnded (event: EventTouch, captureListeners?: Node[]) {
        let transform = this.node.getComponent(UITransform);
        // screen location
        let screenPoint = event.getLocation()  // {"x":779.2784423828125,"y":1581.3411254882812}
        let uiPos = event.getUILocation()        // {"x":519.5189615885416,"y":1054.2274169921875}
        // Have to Sprite with transform.getBoundingBoxToWorld()
        // 0 {"x":40,"y":968.699951171875,"width":283,"height":223}
        // 1 {"x":348,"y":968.699951171875,"width":283,"height":223}
        
        console.log(screenPoint)
        // Check collision by hitTest
        if (transform.hitTest(screenPoint)) {
            console.log(" Transform ... Hit Test")
        }
   
       // check collision by isHit
       if (transform.isHit(uiPos)){
            console.log(" Transform ... isHit")
       }
    }
}

